# reloadAnyResponse plugin for LimeSurvey. #

Allow to reload any response with options.

This plugin was tested on 3.X, quickly tested on some 4.X version and can work on 5.X version.


## Installation

### Via GIT
- Go to your LimeSurvey Directory
- Clone in plugins/addScriptToQuestion directory : `git clone https://gitlab.com/SondagesPro/coreAndTools/reloadAnyResponse.git`

### Via ZIP dowload
- Get the file [reloadAnyResponse.zip](https://extensions.sondages.pro/IMG/auto/reloadAnyResponse.zip)
- Extract : `unzip reloadAnyResponse.zip`
- Move the directory to plugins/ directory inside LimeSurvey

## Usage and options

### Existing options

All of this options exist globally (at plugin settings page) and by survey.

- _Allow admin user to edit response with responseid_ : if an admin user load a survey with param srid : the reponse of the survey with this id are loaded and admin user can edit it.
- _Allow participant with token to create or reload responses_ : With not anonymous survey ; allow user to load specific response. Particullary interseting with answer persistance to off.
- _Allow participant with token in same group to reload response_ : With [Token User Management](https://gitlab.com/SondagesPro/TokenManagement/TokenUsersListAndManage) plugin : response can be reloaded by particpant of same group.
- _Create unique code automatically_ : unique code allow any user knowing this code (and the response id) to reload this response. 
- _Allow using unique code if exist_ : If unique code exist, allow any user knowing it to edit the answer. Parameter used for the access code is `code`. for example usage of link `1234?srid=1&code=accessode` try to load the response id 1 on survey 1234 with unique access code accessode.
- _Extra condition for allowing edition_ : More condition to allow edition : One field by line, field must be a valid question code (single question only). Field and value are separated by colon (<code>:</code>).
- _Time for disable multiple access (in minutes)_ : since editing a response by 2 person at same time can replace current response done : a time for disabling mutiple access for all response done. This was used too with survey with token enable and answer persistence.
- _Throw a 401 error if try to reload without rights._ : When anybody try to access a reponse, rights are tested. If current user didn't have reponse editing rights according to plugin settings and survey settings : you can choose to send a 401 or to let LimeSurvey do the action in this case.
- _Save reloaded response transparently_ : If a response is reloaded, don't ask user and pass when try to save response. With if reloaded with access code or token : this allow admin user to create save link with the default save system of LimeSurvey.
- _Action when using clearall action_ : LimeSurvey core delete response not submitted, and don't delete respnse submitted with token enable survey and allow edition. This parameters allow to choose the action to do when a response is reloaded. **Warning** : to disable default LimeSurvey action `confirm-clearall` post value is set to null in case of reset session only.
- _Replace clearall action even if response is not reloaded_ : You can choose the action to do even if reponse is not reloaded too, this disable default LimeSurvey core action.
- _Reset submitdate on the first action done_ : When a response is reloaded, if it was previously submitted : it stay submitted. This settings allow you to choose if submitdate is updated if allow edit after completion is set. In case of allow edit after completion not set : submitdate is always reset.
- _Keep max page seen when load and save_ : create a max page in database if needed , allow to save max step and set it when reload response. If you allow index this keep the index open at the last page.

Only at global plugin settings

- _Replace edit response in browse response interface_ : when an admin user edit a response via admin gui default link : the plugin lauch the survey like it was seen publicly.
- _Delete the link of response when a response is deleted._ : Delete the link with the unique acces code of each response when this one was deleted. default to no, because new response got an new number when survey is activated agaon. Remind : if you use import/export as VV, a new response can replace an old one.
- _Delete the link of all responses of a survey when it's deactivated._ : Delete the existing link when a survey is deactivated. Default to no : this allow to import form an old database.
- _Delete the link of all responses of a survey when it's deleted_ : Delete whole response access code when a survey is deleted. Default to yes.

### Usage as tool for other plugins

The plugin add 2 models for managing existing access code and the multiple access time. You can easily know if plugin exist and is activated with `Yii::getPathOfAlias('reloadAnyResponse')`.

### responseLink model

- Create or find a reponse `$responseLink = \reloadAnyResponse\models\responseLink::setResponseLink($iSurvey,$iResponse,$sToken)`.
- Get a response url with the parameters : `$responseLink->getStartUrl($absolute = true);`

Sample usage
````
    // Get the response link with access code
    $responseLink = \reloadAnyResponse\models\responseLink::setResponseLink(1234,1);
    if($responseLink->hasErrors()) {
        throw new CHttpException(500, \CHtml::$responseLink->errorSummary($responseLink));
    }
    // redirect to this link
    Yii::app()->getController()->redirect($responseLink->getStartUrl());
````

### surveySession model

- save a session time : `\reloadAnyResponse\models\surveySession::saveSessionTime($iSurvey,$iResponse=null)`
- find a current response id is currently edited : `\reloadAnyResponse\models\surveySession::getIsUsed($iSurvey,$iResponse=null)`
- Use current sessionId in your plugins `\reloadAnyResponse\models\surveySession::getSessionId()` for other purpose.

If `$iResponse` is null : get the current response id from `$_SESSION`. The plugin use this model in beforeSurveyPage event if _Time for disable multiple access (in minutes)_ is not empty.

The SessionId is saved in current session, then close browser or logout administration (using log out button) reset the SessionId.

### reloadResponse helper

- This allow to reload any response by another plugin.
- **Warning** no control‘s on right or token are done by this helper, you must control rights in your plugin
- Constructor need surveyid and reponse id and optionnal language
- Start a survey with startSurvey function. Parameters was
    - `$step` The step where to start survey, null get the default from response, false start at 1st page.
    - `$resetSubmit` reset the submit date, by default reset if needed (Allow edit after completion is disabled).

Sample usage in beforeSurveyPage for example.
````
    $reloadReponse = new \reloadAnyResponse\helpers\reloadResponse($surveyId, $srid);
    $reloadReponse->startSurvey($step);
````

### StartUrl utilitie : get start url for other plugin

- Allow to get the valid start url for another plugin, if surey is with token : need token except for admin user.

Sample usage
````
    $oStartUrl = new \reloadAnyResponse\StartUrl($surveyId, $token);
    $startUrl = $oStartUrl->getUrl($srif, array('myparam' => $myValue), true);
    if($startUrl) {
        echo CHtml::link("reload survey",$startUrl);
    }
````

## Contribute and issue

Contribution are welcome, for patch and issue : use [gitlab]( https://gitlab.com/SondagesPro/coreAndTools/reloadAnyResponse).

## Home page & Copyright
- HomePage <https://extensions.sondages.pro/rubrique33>
- Copyright © 2018-2019 Denis Chenu <http://sondages.pro>
- Licence : GNU Affero General Public License <https://www.gnu.org/licenses/agpl-3.0.html>
- [![Donate](https://liberapay.com/assets/widgets/donate.svg)](https://liberapay.com/SondagesPro/) : [Donate on Liberapay](https://liberapay.com/SondagesPro/) 
